{$if not def DOS_DOS_H} CONST DOS_DOS_H=0;

{ ***********************************************************
  ** KickPascal-Include-Datei "dos/dos.h" zu Kickstart 3.0 **
  *********************************************************** }

TYPE p_DateStamp = ^DateStamp;
TYPE p_FileInfoBlock = ^FileInfoBlock;
TYPE BPTR = Long;
TYPE BSTR = Long;
TYPE p_InfoData = ^InfoData;

CONST DOSNAME  = "dos.library";

CONST
 DOSTRUE   = -1;
 DOSFALSE  =  0;

CONST
 MODE_OLDFILE    = 1005;
 MODE_NEWFILE    = 1006;
 MODE_READWRITE  = 1004;

CONST
 OFFSET_BEGINNING = -1;
 OFFSET_CURRENT   =  0;
 OFFSET_END       =  1;
 OFFSET_BEGINING  =  OFFSET_BEGINNING;

CONST
 BITSPERBYTE  =  8;
 BYTESPERLONG =  4;
 BITSPERLONG  = 32;
 _MAXINT      = $7FFFFFFF;  { "_" ergnzt! }
 DOSMAXINT    = _MAXINT;    { "DOS" ergnzt! }
 _MININT      = $80000000;  { "_" ergnzt! }
 DOSMININT    = _MININT;    { "DOS" ergnzt! }

CONST
 SHARED_LOCK    = -2;
 ACCESS_READ    = -2;
 EXCLUSIVE_LOCK = -1;
 ACCESS_WRITE   = -1;

TYPE DateStamp = RECORD
 ds_Days   : LongInt;
 ds_Minute : LongInt;
 ds_Tick   : LongInt;
END;

CONST TICKS_PER_SECOND = 50;


TYPE FileInfoBlock = RECORD
 fib_DiskKey      : LongInt;
 fib_DirEntryType : LongInt;
 fib_FileName     : String[108];
 fib_Protection   : LongInt;
 fib_EntryType    : LongInt;
 fib_Size         : LongInt;
 fib_NumBlocks    : LongInt
 fib_Date         : DateStamp;
 fib_Comment      : String[80];
 fib_OwnerUID     : Word;
 fib_OwnerGID     : Word;
 fib_Reserved     : String[32];
END;

CONST
 FIBB_OTR_READ   = 15;
 FIBB_OTR_WRITE  = 14;
 FIBB_OTR_EXECUTE= 13;
 FIBB_OTR_DELETE = 12;
 FIBB_GRP_READ   = 11;
 FIBB_GRP_WRITE  = 10;
 FIBB_GRP_EXECUTE=  9;
 FIBB_GRP_DELETE =  8;

 FIBB_SCRIPT  = 6;
 FIBB_PURE    = 5;
 FIBB_ARCHIVE = 4;
 FIBB_READ    = 3;
 FIBB_WRITE   = 2;
 FIBB_EXECUTE = 1;
 FIBB_DELETE  = 0;


 FIBF_OTR_READ   = $8000;
 FIBF_OTR_WRITE  = $4000;
 FIBF_OTR_EXECUTE= $2000;
 FIBF_OTR_DELETE = $1000;
 FIBF_GRP_READ   = $0800;
 FIBF_GRP_WRITE  = $0400;
 FIBF_GRP_EXECUTE= $0200;
 FIBF_GRP_DELETE = $0100;

 FIBF_SCRIPT  = $40;
 FIBF_PURE    = $20;
 FIBF_ARCHIVE = $10;
 FIBF_READ    = $08;
 FIBF_WRITE   = $04;
 FIBF_EXECUTE = $02;
 FIBF_DELETE  = $01;

CONST FAULT_MAX = 82;


TYPE InfoData = RECORD
 id_NumSoftErrors : LongInt;
 id_UnitNumber    : LongInt;
 id_DiskState     : LongInt;
 id_NumBlocks     : LongInt;
 id_NumBlocksUsed : LongInt;
 id_BytesPerBlock : LongInt;
 id_DiskType      : LongInt;
 id_VolumeNode    : BPTR;
 id_InUse         : LongInt;
END;

CONST
 ID_WRITE_PROTECTED = 80;
 ID_VALIDATING      = 81;
 ID_VALIDATED       = 82;

CONST
 ID_NO_DISK_PRESENT = -1;
 ID_UNREADABLE_DISK = $42414400; { 'BAD\0' }
 ID_DOS_DISK        = $444F5300; { 'DOS\0' }
 ID_FFS_DISK        = $444F5301; { 'DOS\1' }
 ID_NOT_REALLY_DOS  = $4E444F53; { 'NDOS'  }
 ID_KICKSTART_DISK  = $4B49434B; { 'KICK'  }
 ID_MSDOS_DISK      = $4d534400; { 'MSD\0' }

CONST
 ERROR_NO_FREE_STORE            = 103;
 ERROR_TASK_TABLE_FULL          = 105;
 ERROR_BAD_TEMPLATE             = 114;
 ERROR_BAD_NUMBER               = 115;
 ERROR_REQUIRED_ARG_MISSING     = 116;
 ERROR_KEY_NEEDS_ARG            = 117;
 ERROR_TOO_MANY_ARGS            = 118;
 ERROR_UNMATCHED_QUOTES         = 119;
 ERROR_LINE_TOO_LONG            = 120;
 ERROR_FILE_NOT_OBJECT          = 121;
 ERROR_INVALID_RESIDENT_LIBRARY = 122;
 ERROR_NO_DEFAULT_DIR           = 201;
 ERROR_OBJECT_IN_USE            = 202;
 ERROR_OBJECT_EXISTS            = 203;
 ERROR_DIR_NOT_FOUND            = 204;
 ERROR_OBJECT_NOT_FOUND         = 205;
 ERROR_BAD_STREAM_NAME          = 206;
 ERROR_OBJECT_TOO_LARGE         = 207;
 ERROR_ACTION_NOT_KNOWN         = 209;
 ERROR_INVALID_COMPONENT_NAME   = 210;
 ERROR_INVALID_LOCK             = 211;
 ERROR_OBJECT_WRONG_TYPE        = 212;
 ERROR_DISK_NOT_VALIDATED       = 213;
 ERROR_DISK_WRITE_PROTECTED     = 214;
 ERROR_RENAME_ACROSS_DEVICES    = 215;
 ERROR_DIRECTORY_NOT_EMPTY      = 216;
 ERROR_TOO_MANY_LEVELS          = 217;
 ERROR_DEVICE_NOT_MOUNTED       = 218;
 ERROR_SEEK_ERROR               = 219;
 ERROR_COMMENT_TOO_BIG          = 220;
 ERROR_DISK_FULL                = 221;
 ERROR_DELETE_PROTECTED         = 222;
 ERROR_WRITE_PROTECTED          = 223;
 ERROR_READ_PROTECTED           = 224;
 ERROR_NOT_A_DOS_DISK           = 225;
 ERROR_NO_DISK                  = 226;
 ERROR_NO_MORE_ENTRIES          = 232;
{ neu ab Kickstart 1.4 }
 ERROR_IS_SOFT_LINK             = 233;
 ERROR_OBJECT_LINKED            = 234;
 ERROR_BAD_HUNK                 = 235;
 ERROR_NOT_IMPLEMENTED          = 236;
 ERROR_RECORD_NOT_LOCKED        = 240;
 ERROR_LOCK_COLLISION           = 241;
 ERROR_LOCK_TIMEOUT             = 242;
 ERROR_UNLOCK_ERROR             = 243;

CONST
 RETURN_OK    = 0;
 RETURN_WARN  = 5;
 RETURN_ERROR = 10;
 RETURN_FAIL  = 20;

CONST
 SIGBREAKB_CTRL_C = 12;
 SIGBREAKB_CTRL_D = 13;
 SIGBREAKB_CTRL_E = 14;
 SIGBREAKB_CTRL_F = 15;

 SIGBREAKF_CTRL_C = $1000;
 SIGBREAKF_CTRL_D = $2000;
 SIGBREAKF_CTRL_E = $3000;
 SIGBREAKF_CTRL_F = $4000;

CONST
 LOCK_SAME         =  0;
 LOCK_SAME_VOLUME  =  1;
 LOCK_SAME_HANDLER =  LOCK_SAME_VOLUME;
 LOCK_DIFFERENT    = -1;

CONST
 CHANGE_LOCK = 0;
 CHANGE_FH   = 1;

CONST
 LINK_HARD = 0;
 LINK_SOFT = 1;

 ITEM_EQUAL    = -2;
 ITEM_ERROR    = -1;
 ITEM_NOTHING  =  0;
 ITEM_UNQUOTED =  1;
 ITEM_QUOTED   =  2;

CONST
 DOS_FILEHANDLE   = 0;
 DOS_EXALLCONTROL = 1;
 DOS_FIB          = 2;
 DOS_STDPKT       = 3;
 DOS_CLI          = 4;
 DOS_RDARGS       = 5;

{$endif}
