{$if not def DOS_DOSEXTENS_H} CONST DOS_DOSEXTENS_H=0;

{ *****************************************************************
  ** KickPascal-Include-Datei "dos/dosextens.h" zu Kickstart 3.0 **
  ***************************************************************** }

TYPE p_Process = ^Process;
TYPE p_FileHandle = ^_FileHandle;
TYPE p_DosPacket = ^DosPacket;
TYPE p_StandardPacket = ^StandardPacket;
TYPE p_ErrorString = ^ErrorString;
TYPE p_RootNode = ^RootNode;
TYPE p_DosLibrary = ^DosLibrary;
TYPE p_CliProcList = ^CliProcList;
TYPE p_Segment = ^Segment;
TYPE p_DosInfo = ^DosInfo;
TYPE p_CommandLineInterface = ^CommandLineInterface;
TYPE P_DeviceList = ^DeviceList;
TYPE p_DevInfo = ^DevInfo;
TYPE p_AssignList = ^AssignList;
TYPE p_DosList = ^DosList;
TYPE p_DevProc = ^DevProc;
TYPE p_FileLock = ^FileLock;

{$if not def EXEC_TASKS_H;incl "exec/tasks.h";endif}
{$if not def EXEC_PORTS_H;incl "exec/ports.h";endif}
{$if not def EXEC_LIBRARIES_H;incl "exec/libraries.h";endif}
{$if not def EXEC_SEMAPHORES_H;incl "exec/semaphores.h";endif}
{$if not def DEVICES_TIMER_H;incl "devices/timer.h";endif}
{$if not def DOS_DOS_H;incl "dos/dos.h";endif}

TYPE Process = RECORD
 pr_Task           : Task;
 pr_MsgPort        : MsgPort;
 pr_Pad            : Integer;
 pr_SegList        : BPTR;
 pr_StackSize      : Long;
 pr_GlobVec        : Ptr;
 pr_TaskNum        : LongInt;
 pr_StackBase      : BPTR;
 pr_Result2        : LongInt;
 pr_CurrentDir     : BPTR;
 pr_CIS            : BPTR;
 pr_COS            : BPTR;
 pr_ConsoleTask    : Ptr;
 pr_FileSystemTask : Ptr;
 pr_CLI            : BPTR;
 pr_ReturnAddr     : Ptr;
 pr_PktWait        : Ptr;
 pr_WindowPtr      : Ptr;
 { -- ab Kickstart 2.0 -- }
 pr_HomeDir        : BPTR;
 pr_Flags          : LongInt;
 pr_ExitCode       : Ptr;
 pr_ExitData       : LongInt;
 pr_Arguments      : Str;
 pr_LocalVars      : MinList;
 pr_ShellPrivate   : Long;
 pr_CES            : BPTR;
END;

CONST
 PRB_FREESEGLIST = 0;
 PRF_FREESEGLIST = 1;
 PRB_FREECURRDIR = 1;
 PRF_FREECURRDIR = 2;
 PRB_FREECLI     = 2;
 PRF_FREECLI     = 4;
 PRB_CLOSEINPUT  = 3;
 PRF_CLOSEINPUT  = 8;
 PRB_CLOSEOUTPUT = 4;
 PRF_CLOSEOUTPUT = 16;
 PRB_FREEARGS    = 5;
 PRF_FREEARGS    = 32;

TYPE _FileHandle = RECORD
 fh_Link  : p_Message;
 fh_Port  : p_MsgPort;
 fh_Type  : p_MsgPort;
 fh_Buf   : LongInt;
 fh_Pos   : LongInt;
 fh_End   : LongInt;
 fh_Func1 : LongInt; { auch fh_Func1 }
 fh_Func2 : LongInt;
 fh_Func3 : LongInt;
 fh_Arg1  : LongInt; { auch fh_Args }
 fh_Arg2  : LongInt;
END;

TYPE DosPacket = RECORD
 dp_Link : p_Message;
 dp_Port : p_MsgPort;
 dp_Type : LongInt; { auch dp_Action }
 dp_Res1 : LongInt; { auch dp_Status }
 dp_Res2 : LongInt; { auch dp_Status2 }
 dp_Arg1 : LongInt; { auch dp_BufAddr }
 dp_Arg2 : LongInt;
 dp_Arg3 : LongInt;
 dp_Arg4 : LongInt;
 dp_Arg5 : LongInt;
 dp_Arg6 : LongInt;
 dp_Arg7 : LongInt;
END;

TYPE StandardPacket = RECORD
 sp_Msg : Message;
 sp_Pkt : DosPacket;
END;

CONST
 ACTION_NIL            = 0;
 ACTION_STARTUP        = 0;
 ACTION_GET_BLOCK      = 2; { veraltet }
 ACTION_SET_MAP        = 4;
 ACTION_DIE            = 5;
 ACTION_EVENT          = 6;
 ACTION_CURRENT_VOLUME = 7;
 ACTION_LOCATE_OBJECT  = 8;
 ACTION_RENAME_DISK    = 9;
 ACTION_WRITE          = "W";
 ACTION_READ           = "R";
 ACTION_FREE_LOCK      = 15;
 ACTION_DELETE_OBJECT  = 16;
 ACTION_RENAME_OBJECT  = 17;
 ACTION_MORE_CACHE     = 18;
 ACTION_COPY_DIR       = 19;
 ACTION_WAIT_CHAR      = 20;
 ACTION_SET_PROTECT    = 21;
 ACTION_CREATE_DIR     = 22;
 ACTION_EXAMINE_OBJECT = 23;
 ACTION_EXAMINE_NEXT   = 24;
 ACTION_DISK_INFO      = 25;
 ACTION_INFO           = 26;
 ACTION_FLUSH          = 27;
 ACTION_SET_COMMENT    = 28;
 ACTION_PARENT         = 29;
 ACTION_TIMER          = 30;
 ACTION_INHIBIT        = 31;
 ACTION_DISK_TYPE      = 32;
 ACTION_DISK_CHANGE    = 33;
 ACTION_SET_DATE       = 34;

 ACTION_SCREEN_MODE    = 994;

 ACTION_READ_RETURN    = 1001;
 ACTION_WRITE_RETURN   = 1002;
 ACTION_SEEK           = 1008;
 ACTION_FINDUPDATE     = 1004;
 ACTION_FINDINPUT      = 1005;
 ACTION_FINDOUTPUT     = 1006;
 ACTION_END            = 1007;
 ACTION_SET_FILE_SIZE  = 1022;
 ACTION_WRITE_PROTECT  = 1023;

 ACTION_SAME_LOCK      = 40;
 ACTION_CHANGE_SIGNAL  = 995;
 ACTION_FORMAT         = 1020;
 ACTION_MAKE_LINK      = 1021;

 ACTION_READ_LINK      = 1024;
 ACTION_FH_FROM_LOCK   = 1026;
 ACTION_IS_FILESYSTEM  = 1027;
 ACTION_CHANGE_MODE    = 1028;

 ACTION_COPY_DIR_FH    = 1030;
 ACTION_PARENT_FH      = 1031;
 ACTION_EXAMINE_ALL    = 1033;
 ACTION_EXAMINE_FH     = 1034;

 ACTION_LOCK_RECORD    = 2008;
 ACTION_FREE_RECORD    = 2009;

 ACTION_ADD_NOTIFY     = 4097;
 ACTION_REMOVE_NOTIFY  = 4098;

{ -- neu in V39 -- }
 ACTION_EXAMINE_ALL_END= 1035;
 ACTION_SET_OWNER      = 1036;

 ACTION_SERIALIZE_DISK = 4200;


TYPE ErrorString = RECORD
 estr_Nums : ^LongInt;
 estr_Strings : Str;
END;


TYPE RootNode = RECORD
 rn_TaskArray          : BPTR;
 rn_ConsoleSegment     : BPTR;
 rn_Time               : DateStamp;
 rn_RestartSeg         : LongInt;
 rn_Info               : BPTR;
 rn_FileHandlerSegment : BPTR;
 rn_CliList            : MinList;
 rn_BootProc           : p_MsgPort;
 rn_ShellSegment       : BPTR;
 rn_Flags              : LongInt;
END;

TYPE DosLibrary = RECORD
 dl_lib         : _Library;
 dl_Root        : p_RootNode;
 dl_GV          : Ptr;
 dl_A2          : LongInt;
 dl_A5          : LongInt;
 dl_A6          : LongInt;
 dl_Errors      : p_ErrorString;
 dl_TimeReq     : p_timerequest;
 dl_UtilityBase : p_Library;
END;


CONST
 RNB_WILDSTAR = 24;
 RNF_WILDSTAR = $10000000;
 RNB_PRIVATE1 = 1;
 RNF_PRIVATE1 = 2;

TYPE CliProcList = RECORD
 cpl_Node  : MinNode;
 cpl_First : LongInt;
 cpl_Array : Ptr;
END;

TYPE DosInfo = RECORD
 di_McName    : BPTR; { auch di_ResList }
 di_DevInfo   : BPTR;
 di_Devices   : BPTR;
 di_Handlers  : BPTR;
 di_NetHand   : Ptr;
 di_DevLock   : SignalSemaphore;
 di_EntryLock : SignalSemaphore;
 di_DeleteLock: SignalSemaphore;
END;

TYPE Segment = RECORD
 seg_Next : BPTR;
 seg_UC   : Long;
 seg_Seg  : BPTR;
 seg_Name : ARRAY[0..3] OF char;
END;

CONST
 CMD_SYSTEM   = -1;
 CMD_INTERNAL = -2;
 CMD_DISABLED = -999;

TYPE CommandLineInterface = RECORD
 cli_Result2        : LongInt;
 cli_SetName        : BSTR;
 cli_CommandDir     : BPTR;
 cli_ReturnCode     : LongInt;
 cli_CommandName    : BSTR;
 cli_FailLevel      : LongInt;
 cli_Prompt         : BSTR;
 cli_StandardInput  : BPTR;
 cli_CurrentInput   : BPTR;
 cli_CommandFile    : BSTR;
 cli_Interactive    : LongInt;
 cli_Background     : LongInt;
 cli_CurrentOutput  : BPTR;
 cli_DefaultStack   : LongInt;
 cli_StandardOutput : BPTR;
 cli_Module         : BPTR;
END;

TYPE DeviceList = RECORD
 dl_Next       : BPTR;
 dl_Type       : LongInt;
 dl_Task       : p_MsgPort;
 dl_Lock       : BPTR;
 dl_VolumeDate : DateStamp;
 dl_LockList   : BPTR;
 dl_DiskType   : LongInt;
 dl_unused     : LongInt;
 dl_Name       : BSTR;
END;

TYPE DevInfo = RECORD
 dvi_Next      : BPTR;
 dvi_Type      : LongInt;
 dvi_Task      : Ptr;
 dvi_Lock      : BPTR;
 dvi_Handler   : BSTR;
 dvi_StackSize : LongInt;
 dvi_Priority  : LongInt;
 dvi_Startup   : LongInt;
 dvi_SegList   : BPTR;
 dvi_GlobVec   : BPTR;
 dvi_Name      : BSTR;
END;

TYPE AssignList = RECORD
 al_Next : p_AssignList;
 al_Lock : BPTR;
END;


TYPE DosList = RECORD
 dol_Next : BPTR;
 dol_Type : LongInt;
 dol_Task : p_MsgPort;
 dol_Lock : BPTR;
 dol_misc : RECORD
 CASE Integer OF
  0 : (
       dol_handler   : RECORD
       dol_Handler   : BSTR;
       dol_StackSize : LongInt;
       dol_Priority  : LongInt;
       dol_Startup   : Long;
       dol_SegList   : BPTR;
       dol_GlobVec   : BPTR;
       END
      );
  1 : (
       dol_volume     : RECORD
       dol_VolumeDate : DateStamp;
       dol_LockList   : BPTR;
       dol_DiskType   : LongInt;
       END
      );
  2 : (
       dol_assign     : RECORD
       dol_AssignName : Str;
       dol_List       : p_AssignList;
       END
      );
  END;

 dol_Name : BSTR;
END;


CONST
 DLT_DEVICE     = 0;
 DLT_DIRECTORY  = 1;
 DLT_VOLUME     = 2;
 DLT_LATE       = 3;
 DLT_NONBINDING = 4;
 DLT_PRIVATE    = -1;

TYPE DevProc = RECORD
 dvp_Port    : p_MsgPort;
 dvp_Lock    : BPTR;
 dvp_Flags   : Long;
 dvp_DevNode : p_DosList;
END;

CONST
 DVPB_UNLOCK = 0;
 DVPF_UNLOCK = $1;
 DVPB_ASSIGN = 1;
 DVPF_ASSIGN = $2;

CONST
 LDB_DEVICES = 2;
 LDF_DEVICES = $4;
 LDB_VOLUMES = 3;
 LDF_VOLUMES = $8;
 LDB_ASSIGNS = 4;
 LDF_ASSIGNS = $10;
 LDB_ENTRY   = 5;
 LDF_ENTRY   = $20;
 LDB_DELETE  = 6;
 LDF_DELETE  = $40;

CONST
 LDB_READ  = 0;
 LDF_READ  = $1;
 LDB_WRITE = 1;
 LDF_WRITE = $2;

CONST LDF_ALL = (LDF_DEVICES or LDF_VOLUMES or LDF_ASSIGNS);

TYPE FileLock = RECORD
 fl_Link   : BPTR;
 fl_Key    : LongInt;
 fl_Access : LongInt;
 fl_Task   : p_MsgPort;
 fl_Volume : BPTR;
END;

CONST
 REPORT_STREAM = 0;
 REPORT_TASK   = 1;
 REPORT_LOCK   = 2;
 REPORT_VOLUME = 3;
 REPORT_INSERT = 4;

CONST
 ABORT_DISK_ERROR = 296;
 ABORT_BUSY       = 288;

CONST
 RUN_EXECUTE       = -1;
 RUN_SYSTEM        = -2;
 RUN_SYSTEM_ASYNCH = -3;

CONST
 ST_ROOT     =  1;
 ST_USERDIR  =  2;
 ST_SOFTLINK =  3;
 ST_LINKDIR  =  4;
 ST_FILE     = -3;
 ST_LINKFILE = -4;

{$endif}
